package com.mobai.webMagic.util;

import us.codecraft.webmagic.Page;
import us.codecraft.webmagic.Site;
import us.codecraft.webmagic.Spider;
import us.codecraft.webmagic.processor.PageProcessor;

import java.util.List;

public class ImageProcessor implements PageProcessor {

    private Site site = Site.me().setTimeOut(10000);

    public void process(Page page) {
        //获取图片对应的URL
        List<String> urlList = page.getHtml().$("div[id=content]").xpath("//div/a/img/@src").all();
        // 下载每一张图片
        for (int i = 0; i < urlList.size(); i++) {
            // http://www.nanshan.edu.cn/__local/2/4D/93/76F03CB6EBE3BFB7018397B37D4_C03E3A0C_36A9C.png
            String inputUrl = "http://www.nanshan.edu.cn" + urlList.get(i);
            ImageDownloaderUtil.downLoadImage(inputUrl, "image/" + inputUrl.split("/")[5]);
        }
        //获取下一页的url
        String next = page.getHtml().xpath("//*[@id=\"content\"]/ul[2]/li[@class='nextPage']").links().get();
        page.addTargetRequest(next);
    }

    public Site getSite() {
        return site;
    }


    public static void main(String[] args) {
        Spider.create(new ImageProcessor())
                .addUrl("https://www.socwall.com")
                .thread(5)
                .run();
    }
}
